﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private lblcolor As Label
	Private lblnamedcolor As Label
	Private Button1 As Button
	Private clv1 As CustomListView
	Private jlst As List
	Private RGB As List
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page12_layout")
	B4XPages.SetTitle(Me,"page12 - 12. Named colors selection clv")
	Dim jstr As String = File.ReadString(File.DirAssets,"colornames.json")
	jlst = jstr.As(JSON).ToList
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	For i = 1 To jlst.Size -1
		Dim rec As List = jlst.Get(i)
		Dim pn As Panel = set_clv1_item(rec,i)
		clv1.Add(pn,rec.Get(2))
	Next
End Sub
Private Sub set_clv1_item(rec As List,index As Int) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 60dip)
	pn.LoadLayout("clv1page12item_layout")
	Dim clrstr As String = rec.Get(3)			' red, green, blue
	RGB = set_RGB_values(clrstr)
	lblcolor.TextColor = ContrastColor(xui.Color_ARGB(255,RGB.get(0),RGB.get(1),RGB.get(2)))
	lblcolor.Text = " " & index
	lblcolor.Color = xui.Color_ARGB(255,RGB.get(0),RGB.get(1),RGB.get(2))
	lblnamedcolor.Text = " " & rec.Get(1) & " " & rec.Get(2)
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim info As String = $"Item index: ${index}
Item value: ${value}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
Public Sub set_RGB_values(clrstr As String) As List
	' clrstr = red,green,blue
	Dim lst As List
	lst.Initialize
	lst.Add(clrstr.SubString2(0,clrstr.IndexOf(",")))
	lst.Add(clrstr.SubString2(clrstr.IndexOf(",")+1,clrstr.LastIndexOf(",")))
	lst.Add(clrstr.SubString(clrstr.LastIndexOf(",")+1))
	Return lst
End Sub
Public Sub ContrastColor(Color As Int) As Int
	Dim lum As Double = 1 - (0.299 * Bit.And(Bit.ShiftRight(Color,16),0xFF) + 0.587 * Bit.And(Bit.ShiftRight(Color,8),0XFF) + 0.114 * Bit.And(Color,0xFF)) / 255
	If lum < 0.5 Then
		Return xui.Color_Black
	Else
		Return xui.Color_White
	End If
End Sub
