﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private hclv As CustomListView
	Private bivhclv As B4XImageView
	Private lblhclvitem As Label
	Private Button1 As Button
	Private clv1 As CustomListView
	Public photodialog As B4XDialog
	Public bivdialog As B4XImageView
	Public lbldialogdescription As Label
	Public lbldialogtitle As Label
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page13_layout")
	B4XPages.SetTitle(Me,"page13 - 13. Horizontal clv's in vertical clv")
	photodialog.Initialize(Root)
	photodialog.PutAtTop = True
	photodialog.BodyTextColor = xui.Color_Blue
	photodialog.BackgroundColor = xui.Color_LightGray
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	For i = 0 To 5
		Dim pnl As Panel = set_clv1_item(i, "")
		clv1.Add(pnl,"Album " & i)
	Next
End Sub
Private Sub set_clv1_item(index As Int, descr As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip,150dip)
	pn.LoadLayout("clv1page13item_layout")
	fill_hclv(index)
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub fill_hclv(clv1index As Int)
	hclv.Clear
	Dim fnames As List = get_filenames
	Dim itemlst As List = get_titleitems
	For i = 0 To itemlst.Size -1
		Dim item As String = itemlst.Get(i)
		Dim fname As String = fnames.Get(i)
		Dim pnl As Panel = set_hclv_item(i, fname, item)
		hclv.Add(pnl,clv1index)
	Next
End Sub
Private Sub set_hclv_item(index As Int, fname As String, title As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 110dip,130dip)
	pn.LoadLayout("hclvpage13item_layout")
	bivhclv.Load(File.DirAssets,fname)
	bivhclv.Tag = fname
	lblhclvitem.Text = title
	Return pn
End Sub
Private Sub hclv_ItemClick (Index As Int, Value As Object)
	Dim biv As B4XImageView = hclv.GetPanel(Index).GetView(0).Tag
	Dim fname As String = biv.tag
	Dim title As String = hclv.GetPanel(Index).GetView(1).Text
	show_imagefile_dialog(fname,title,"Album: " & Value & " Index: " & Index)
End Sub
Private Sub get_filenames As List
	Dim fnamelst As List = Array As String("amalfi_coast_italy_small.png", "aurora_borealis_iceland_small.png", _
						"banff_national_park_canada_small.png", "machu_picchu_peru_small.png", "maldives_small.png", _
						"mount_fuji_japan_small.png","santorini_greece_small.png")
	Return fnamelst
End Sub
Private Sub get_titleitems As List
	Dim itlst As List = Array As String("Italy", "Iceland", "Canada", "Peru", "Maldives","Japan","Greece")
	Return itlst
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim info As String = $"List item index: ${index}
Item value: ${value}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
Sub show_imagefile_dialog(imgfile As String, title As String, descr As String)
	Dim pnl1 As Panel = setup_imagefile_dialog("photodialog_layout",imgfile,title,descr)
	Wait For (photodialog.ShowCustom(pnl1, "OK", "", "")) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		'
	End If
End Sub
Sub setup_imagefile_dialog(strlayout As String,fname As String,title As String,descr As String) As Panel
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 370dip)
	pnl.LoadLayout(strlayout)
	lbldialogtitle.Text = title
	lbldialogdescription.Text = descr
	bivdialog.Load(File.DirAssets,fname)
	Return pnl
End Sub
Private Sub biv_Click
	Dim pn As Panel = Sender
	Dim tag As Int = pn.Tag
	Dim biv As B4XImageView = pn.GetView(0).Tag
	Dim vwtext As String = biv.Tag
	Dim info As String = $"Item index: ${tag}
	File name: ${vwtext}"$
	xui.MsgboxAsync(info,"Image info")
End Sub