﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Button1 As Button
	Private clv1 As CustomListView
	Private lblname As Label
	Private lblcity As Label
	Private lbltelephone As Label
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page3_layout")
	B4XPages.SetTitle(Me,"page3 - 3. Label items")
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim itemsmap As Map = get_labelitems
	Dim names As List = itemsmap.Get("names")
	Dim cities As List = itemsmap.Get("cities")
	Dim telephonenumbers As List = itemsmap.Get("telephonenumbers")
	For i = 0 To names.Size -1
		Dim pnl As Panel = set_clv1_item(i, names.Get(i), cities.Get(i), telephonenumbers.Get(i))
		clv1.Add(pnl,names.Get(i))
	Next
End Sub
Private Sub set_clv1_item(index As Int, name As String, city As String, phonenumber As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip,70dip)
	pn.LoadLayout("clv1page3item_layout")
	lblname.Text = name
	lblname.Tag = index
	lblcity.Text = city
	lblcity.Tag = index
	lbltelephone.Text = phonenumber
	lbltelephone.Tag = index
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub get_labelitems As Map
	Dim nmlst As List = Array As String("Charlie", "Frieda", "Hugo", "Ingrid", "Ron")
	Dim citylst As List = Array As String("Los Angeles", "Stockholm", "Antwerp", "Kopenhagen", "London")
	Dim phonelst As List = Array As String("01 458 447 325", "05 458 448 365", "02 235 668 748", "55 698 774 321", "04 558 788 996")
	Dim rows As Map = CreateMap("names":nmlst,"cities":citylst,"telephonenumbers":phonelst)
	Return rows
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext0 As String = clv1.GetPanel(index).GetView(0).Text
	Dim vwtext1 As String = clv1.GetPanel(index).GetView(1).Text
	Dim vwtext2 As String = clv1.GetPanel(index).GetView(2).Text
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Views Text properties:
${vwtext0} - ${vwtext1} - ${vwtext2}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
Private Sub lbl_Click
	Dim view As B4XView = Sender
	Dim tag As Int = view.Tag
	Dim vwtext As String = view.Text
	Dim info As String = $"Item index: ${tag}
Label value: ${vwtext}"$
	xui.MsgboxAsync(info,"Label info")
End Sub
