﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private brb1 As B4XRadioButton
	Private lbldescription As Label
	Private Button1 As Button
	Private clv1 As CustomListView
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page4_layout")
	B4XPages.SetTitle(Me,"page4 - 4. Radiobutton and label items")
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim descriptions As List = get_labelitems
	For i = 0 To descriptions.Size -1
		Dim pnl As Panel = set_clv1_item(i, descriptions.Get(i))
		clv1.Add(pnl,descriptions.Get(i))
	Next
End Sub
Private Sub set_clv1_item(index As Int, description As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip,70dip)
	pn.LoadLayout("clv1page4item_layout")
	brb1.Checked = False
	brb1.Tag = index
	lbldescription.Text = description
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	' a XUI Views view has a type of CustomView - the view is available in the tag by default
	Dim vw As B4XRadioButton = clv1.GetPanel(Index).GetView(0).Tag
	If vw.Checked = False Then
		vw.Checked = True
		Dim descr As String = clv1.GetPanel(Index).GetView(1).Text
		clv1.GetPanel(Index).GetView(1).Text = descr & " DONE."
	End If
	show_selection_info(Index,Value)
End Sub
Private Sub get_labelitems As List
	Dim descrlst As List = Array As String("go shopping", "create a new app", _
										   "check email", "go to dinner", "watch a video", _
										   "write a tutorial","visit friends", "sleep")
	Return descrlst
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext As String = clv1.GetPanel(index).GetView(1).Text
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Label Text property:
${vwtext}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
Private Sub brb1_Checked
	Dim brbsel As B4XRadioButton = Sender
	If brbsel.Checked = False Then Return
	Dim tag As Int = brbsel.Tag
	Dim descr As String = clv1.GetPanel(tag).GetView(1).Text
	clv1.GetPanel(tag).GetView(1).Text = descr & " DONE."
End Sub