﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public checkbx1 As CheckBox
	Public lblname As Label
	Private Button1 As Button
	Private clv1 As CustomListView
	Private selitem As Int
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page5_layout")
	B4XPages.SetTitle(Me,"page5 - 5. Checkbox and label items - One selection")
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim names As List = Array As String("Peter","Ann","Nick","Sandra","John")
	For i = 0 To 4
		Dim pnl As Panel = set_clv1_item("clv1page5item_layout",i,names.Get(i))
		clv1.Add(pnl,i)
	Next
End Sub
Private Sub set_clv1_item(strlayout As String, index As Int, name As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip,70dip)
	pn.LoadLayout(strlayout)
	checkbx1.Checked = False
	checkbx1.Tag = index
	lblname.Text = name
	Return pn
End Sub
Private Sub checkbx1_CheckedChange(Checked As Boolean)
	If Checked = False Then Return			' only change when a checkbox is checked
	Dim cbxsel As CheckBox = Sender
	If cbxsel.IsInitialized = False Then cbxsel = clv1.GetPanel(selitem).GetView(0)
	Dim tag As Int = cbxsel.Tag
	For i = 0 To clv1.Size -1
		If i <> tag Then
			clv1.GetPanel(i).GetView(0).Checked = False
		Else
			clv1.GetPanel(i).GetView(0).Checked = True			
		End If
	Next
	show_selection_info(tag,clv1.GetPanel(tag).GetView(1).Text)
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	If clv1.GetPanel(Index).GetView(0).Checked = False Then
		selitem = Index
		clv1.GetPanel(Index).GetView(0).Checked = True	' checkbox property checked
'		show_selection_info(Index,Value)
	End If
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext As String = clv1.GetPanel(index).GetView(1).Text
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Label Text property:
${vwtext}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
