﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Public checkbx1 As CheckBox
	Public lblname As Label
	Private Button1 As Button
	Private clv1 As CustomListView
	Private selected As List
	Private selitem As Int
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page6_layout")
	B4XPages.SetTitle(Me,"page6 - 6. Checkbox and label items - Multiple selections")
	selected.Initialize
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim names As List = Array As String("Jan","Paul","Donna","Eric","Stefan")
	For i = 0 To 4
		Dim pnl As Panel = set_clv1_item("clv1page6item_layout",i,names.Get(i))
		clv1.Add(pnl,i)
	Next
End Sub
Private Sub set_clv1_item(strlayout As String, index As Int, name As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip,70dip)
	pn.LoadLayout(strlayout)
	checkbx1.Checked = False
	checkbx1.Tag = index
	lblname.Text = name
	Return pn
End Sub
Private Sub checkbx1_CheckedChange(Checked As Boolean)
	Dim cbxsel As CheckBox = Sender
	If cbxsel.IsInitialized = False Then cbxsel = clv1.GetPanel(selitem).GetView(0)
	Dim tag As Int = cbxsel.Tag
	show_selection_info(tag,clv1.GetPanel(tag).GetView(1).Text)
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	If clv1.GetPanel(Index).GetView(0).Checked = False Then
		selitem = Index
		clv1.GetPanel(Index).GetView(0).Checked = True
	Else
		selitem = Index
		clv1.GetPanel(Index).GetView(0).Checked = False
	End If
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext As String = clv1.GetPanel(index).GetView(1).Text
	selected.Clear
	For i = 0 To clv1.Size -1
		If clv1.GetPanel(i).GetView(0).Checked = True Then
			selected.Add(clv1.GetPanel(i).GetView(1).Text)	' selected items list
		End If
	Next
	Dim selstring As String = ""
	For i = 0 To selected.Size -1
		selstring = selstring & selected.Get(i) & ","
	Next
	If selstring <> "" Then selstring = selstring.SubString2(0,selstring.Length-1)
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Label Text property:
${vwtext}
Selected so far:
${selstring}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
