﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Button1 As Button
	Private clv1 As CustomListView
	Private lblamount As Label
	Private lblcategory As Label
	Private lblcurrency As Label
	Private lbldate As Label
	Private lbldescription As Label
	Private pncard As Panel
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("page11_layout")
	B4XPages.SetTitle(Me,"page11 - 11. Card panel items")
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim itemsmap As Map = get_labelitems
	Dim dates As List = itemsmap.Get("dates")
	Dim amounts As List = itemsmap.Get("amounts")
	Dim categories As List = itemsmap.Get("categories")
	Dim descriptions As List = itemsmap.Get("descriptions")
	For i = 0 To dates.Size -1
		Dim pnl As Panel = set_clv1_item(i, dates.Get(i), amounts.Get(i), categories.Get(i),descriptions.Get(i))
		clv1.Add(pnl,i)
	Next
End Sub
Private Sub set_clv1_item(index As Int, date As String, amount As String, category As String, description As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 430dip,130dip)
	pn.LoadLayout("clv1page11item_layout")
	lbldate.Text = date
	lblcurrency.Text = "(EUR)"
	lblamount.Text = amount
	lblamount.As(B4XView).TextColor = xui.Color_Red
	lblcategory.Text = category
	lbldescription.Text = description
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub get_labelitems As Map
	Dim datelst As List = Array As String("2024-10-02", "2024-10-05", "2024-10-10", "2024-10-22", "2024-10-26")
	Dim amountlst As List = Array As String("-300.00", "-250.00", "-140.00", "-650.00", "-360.00")
	Dim categorylst As List = Array As String("cash", "transfer", "shopping", "rent", "loan")
	Dim descriptionlst As List = Array As String("spending money", "to my savings account", "in town", "for my landlord", "installment payment")
	Dim rows As Map = CreateMap("dates":datelst,"amounts":amountlst,"categories":categorylst,"descriptions":descriptionlst)
	Return rows
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext0 As String = clv1.GetPanel(index).GetView(0).GetView(0).Text
	Dim vwtext1 As String = clv1.GetPanel(index).GetView(0).GetView(1).Text
	Dim vwtext2 As String = clv1.GetPanel(index).GetView(0).GetView(2).Text
	Dim vwtext3 As String = clv1.GetPanel(index).GetView(0).GetView(3).Text
	Dim vwtext4 As String = clv1.GetPanel(index).GetView(0).GetView(4).Text
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Views Text properties:
${vwtext0}  ${vwtext1}  ${vwtext2}
${vwtext3}  ${vwtext4}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
