﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Button1 As Button
	Private clv1 As CustomListView
	Private pnclvitem As Panel
	Public clvdeflist As CustomListView
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page14_layout")
	B4XPages.SetTitle(Me,"page14 - 14. Clv items with different layout")
End Sub
Private Sub B4XPage_Appear
	fill_clv1
	clv1_ItemClick (0, 45dip)
	clv1_ItemClick (1, 45dip)
	clv1_ItemClick (2, 45dip)
	clv1_ItemClick (3, 45dip)
	clv1_ItemClick (4, 45dip)
	fill_default_list
End Sub
Private Sub fill_clv1
	clv1.Clear
	pnclvitem.Initialize("")
	Dim pn As Panel = set_clv1_item("clv1page14itemdefaults_layout")
	clv1.Add(pn,pn.Height)
	Dim pn As Panel = set_clv1_item("clv1page14itemcompinfo_layout")
	clv1.Add(pn,pn.Height)
	Dim pn As Panel = set_clv1_item("clv1page14itembackground_layout")
	clv1.Add(pn,pn.Height)
	Dim pn As Panel = set_clv1_item("clv1page14itemborder_layout")
	clv1.Add(pn,pn.Height)
	Dim pn As Panel = set_clv1_item("clv1page14itemtext_layout")
	clv1.Add(pn,pn.Height)
End Sub
Private Sub set_clv1_item(strlayout As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip,300dip)
	pn.LoadLayout(strlayout)
	pn.SetLayoutAnimated(0, 0dip, 0dip, pnclvitem.Width,pnclvitem.Height)
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	If clv1.GetPanel(Index).Height > 50dip Then
		clv1.ResizeItem(Index,50dip)
	Else
		clv1.ResizeItem(Index,Value)
	End If
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Public Sub fill_default_list
	clvdeflist.Clear
	Dim lst As List = Array As String("default 1","default 2","default 3","default 4", _
									  "default 5","default 6","default 7")
	If lst.Size < 1 Then Return
	For i = 0 To lst.Size -1
		'Log(lst.Get(i))
		clvdeflist.AddTextItem(lst.Get(i),lst.Get(i))
		clvdeflist.ResizeItem(i,50dip)
	Next
End Sub
Private Sub clvdeflist_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim info As String = $"Index: ${index}
Item value: ${value}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
