﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Button1 As Button
	Private clv1 As CustomListView
	Public lblmessage As Label
	Public lblname As Label
	Private pncard As Panel
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page16_layout")
	B4XPages.SetTitle(Me,"page16 - 16. Chat messages")
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim itemsmap As Map = get_labelitems
	Dim names As List = itemsmap.Get("names")
	Dim lstColors As List = itemsmap.Get("colors")
	Dim messages As List = itemsmap.Get("messages")
	For i = 0 To names.Size -1
		If (i Mod 2) = 0 Then
			Dim pnl As Panel = set_clv1_item(i, "clv1page16item_left_layout", names.Get(i), lstColors.Get(i), messages.Get(i))
		Else
			Dim pnl As Panel = set_clv1_item(i, "clv1page16item_right_layout", names.Get(i), lstColors.Get(i), messages.Get(i))
		End If
		clv1.Add(pnl,i)
	Next
	Sleep(0)
	clv1.ScrollToItem(clv1.Size-1)
End Sub
Private Sub set_clv1_item(index As Int, strlayout As String, name As String, color As String, message As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.LoadLayout(strlayout)
	pn.SetLayoutAnimated(0, 0dip, 0dip, 340dip, 140dip)
	pncard.As(B4XView).Color = HexToColor(color)
	lblname.Text = name
	lblmessage.Text = message
	Return pn
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub get_labelitems As Map
	Dim nameslst As List = Array As String("John", "Paul", "Judy", "Peter", "Anna")
	Dim colorslst As List = Array As String("#E6E6FA", "#FFFFA3", "#98FB98", "#FFA07A", "#D8BFD8")
	Dim messageslst As List = Array As String("Hi there, what are you doing?", "I am writing a program.", _
						"Would you like to go shopping with me?", "Sure, why not.", _
						"See you later. This is a very long text to show what happens when it is displayed in the listview. The text will go until the label is full and then the three dots wil be displayed in B4J. So with this line the text will be to long.END")
	Dim rows As Map = CreateMap("names":nameslst,"colors":colorslst,"messages":messageslst)
	Return rows
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext0 As String = clv1.GetPanel(index).GetView(0).GetView(0).Text
	Dim vwtext1 As String = clv1.GetPanel(index).GetView(0).GetView(1).Text
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Views Text properties:
${vwtext0}  ${vwtext1}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
Private Sub lbl_Click
	Dim view As B4XView = Sender
	Dim tag As Int = view.Tag
	Dim vwtext As String = view.Text
	Dim info As String = $"Item index: ${tag}
Label value: ${vwtext}"$
	xui.MsgboxAsync(info,"Label info")
End Sub

Public Sub HexToColor(Hex As String) As Int
	Dim bc As ByteConverter
	If Hex.StartsWith("#") Then
		Hex = "FF" & Hex.SubString(1)
	Else If Hex.StartsWith("0x") Then
		Hex = Hex.SubString(2)
		Log("hex: " & Hex)
	End If
	Dim ints() As Int = bc.IntsFromBytes(bc.HexToBytes(Hex))
	Return ints(0)
End Sub
