﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Button1 As Button
	Private clv1 As CustomListView
	Private lbldistrict As Label
	Private lbllatitude As Label
	Private lbllongitude As Label
	Private lblprovince As Label
	Private lbltown As Label
	Private Label1 As Label
	Private Label2 As Label
	Private Label3 As Label
	Private Label4 As Label
	Private Label5 As Label
	Public labels As List
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page17_layout")
	B4XPages.SetTitle(Me,"page17 - 17. CLV with lazy loading")
	labels = Array As String("จังหวัด:","อำเภอ:","ตำบล:","ละติดจูด:","ลองติดจูด:")
End Sub
Private Sub B4XPage_Appear
	fill_blank_clv_items
	clv1.ScrollToItem(0)			' start from the first item every time
	clv1_VisibleRangeChanged(0,3)
End Sub
Private Sub fill_blank_clv_items
	clv1.Clear
	Try
		Dim datastring As String = File.ReadString(File.DirAssets,"tambon.csv")
		Dim datalst As List = Regex.Split(CRLF,datastring)
		For i = 1 To datalst.Size -1
			Dim rec As String = datalst.Get(i)
			Dim p As B4XView = xui.CreatePanel("")
			p.Color = xui.Color_White
			p.SetLayoutAnimated(0, 0dip, 0dip, 430dip,150dip)
			clv1.Add(p, rec)
		Next
	Catch
		Log(LastException)
		xui.MsgboxAsync("The data file is missing.","Data file")
	End Try
End Sub
Private Sub clv1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim ExtraSize As Int = 5
	For i = 0 To clv1.Size - 1
		Dim p As B4XView = clv1.GetPanel(i)
		If i > FirstIndex - ExtraSize And i < LastIndex + ExtraSize Then
			'visible
			If p.NumberOfViews = 0 Then
				Dim rec As String = clv1.GetValue(i)
				p.LoadLayout("clv1page17item_layout")
				p.SetLayoutAnimated(0, 0dip, 0dip, 430dip,150dip)
				Label1.Text = labels.Get(0) 	' "จังหวัด:"
				Label2.Text = labels.Get(1)		' "อำเภอ:"
				Label3.Text = labels.Get(2)		' "ตำบล:"
				Label4.Text = labels.Get(3)		' "ละติดจูด:"
				Label5.Text = labels.Get(4)		' "ลองติดจูด:"
				Dim fldlst As List = Regex.Split(",",rec)
				lblprovince.Text = fldlst.Get(8)
				lbldistrict.Text = fldlst.Get(5)
				lbltown.Text = fldlst.Get(2)
				lbllatitude.Text = fldlst.Get(10)
				lbllongitude.Text = fldlst.Get(11)
			End If
		Else
			'not visible
			If p.NumberOfViews > 0 Then
				p.RemoveAllViews			' remove the labels from the panel
			End If
		End If
	Next
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	show_selection_info(Index,Value)
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext0 As String = clv1.GetPanel(index).GetView(0).GetView(0).Text
	Dim vwtext1 As String = clv1.GetPanel(index).GetView(0).GetView(1).Text
	Dim vwtext2 As String = clv1.GetPanel(index).GetView(0).GetView(2).Text
	Dim vwtext3 As String = clv1.GetPanel(index).GetView(0).GetView(3).Text
	Dim vwtext4 As String = clv1.GetPanel(index).GetView(0).GetView(4).Text
	Dim info As String = $"Item index: ${index}
Item value: ${value}
Views Text properties:
${vwtext0}  ${vwtext1}  ${vwtext2}
${vwtext3}  ${vwtext4}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub