﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private Label1 As Label
	Private edt1 As EditText
	Private tbtnmore As ToggleButton
	Private Button1 As Button
	Private clv1 As CustomListView
	Public notesmap As Map
	Private dragger As CLVDragger
	Public selectedindex As Int
	Public itemcnt As Int = 0
	Public is_selected As Boolean
End Sub
Public Sub Initialize As Object
	Return Me
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("page9_layout")
	B4XPages.SetTitle(Me,"page9 - 9. Draggable expandable items")
	notesmap.Initialize
	notesmap.Clear
	notesmap = set_notes_map
	dragger.Initialize(clv1)
	dragger.AddDragButtons
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub
Private Sub fill_clv1
	clv1.Clear
	Dim itemlst As List = get_textitems
	For i = 0 To itemlst.Size -1
		Dim item As String = itemlst.Get(i)
		Dim note As String = notesmap.Get(item)
		Dim pn As Panel = set_clv1_item(i,item,note)
		clv1.Add(pn,itemlst.Get(i))
		dragger.AddDragButtons
	Next
End Sub
Private Sub set_clv1_item(index As Int, name As String, note As String) As Panel
	Dim pn As Panel
	pn.Initialize("")
	pn.SetLayoutAnimated(0, 0, 0, 340dip,190dip)
	pn.LoadLayout("clv1page9item_layout")
	pn.Height = 40dip
	pn.Width = pn.Width
	Label1.Text = name
	edt1.Text = note
	edt1.Tag = index
	tbtnmore.Tag = index
	tbtnmore.Checked = False
	Return pn
End Sub
Public Sub clv1_reindex
	For i = 0 To clv1.Size -1
		clv1.GetPanel(i).GetView(0).Tag = i
		clv1.GetPanel(i).GetView(1).Tag = i
		clv1.GetPanel(i).GetView(2).Tag = i
	Next
	dragger.Initialize(clv1)
	dragger.AddDragButtons
	itemcnt = clv1.Size -1
	selectedindex = itemcnt
	is_selected = False
End Sub

Private Sub clv1_ItemClick (Index As Int, Value As Object)
	For i = 0 To clv1.Size -1
		If i = Index Then
			Dim tbtn As ToggleButton = clv1.GetPanel(i).GetView(1)
			tbtn.Checked = True
		Else
			Dim tbtn As ToggleButton = clv1.GetPanel(i).GetView(1)
			tbtn.Checked = False
		End If
	Next
	show_selection_info(Index,Value)
End Sub
Private Sub get_textitems As List
	Dim itlst As List = Array As String("Charlie", "Frieda", "Hugo", "Ingrid", "Ron")
	Return itlst
End Sub
Private Sub set_notes_map As Map
	Dim nmap As Map = CreateMap("Charlie":"a great actor","Frieda":"she can sing", _
								"Hugo":"a famous writer","Ingrid":"she knows how to fight", _
								"Ron":"an actor who became a director")
	Return nmap
End Sub
Private Sub Button1_Click
	B4XPages.ClosePage(Me)
End Sub
Private Sub show_selection_info(index As Int, value As Object)
	Dim vwtext As String = clv1.GetPanel(index).GetView(0).Text	' the internal panel and label view
	Dim info As String = $"Item index: ${index}
Item value: ${value}
First view (0) Text property:
${vwtext}"$
	xui.MsgboxAsync(info,"Selection info")
'	Log(info)
End Sub
Private Sub tbtnmore_CheckedChange(Checked As Boolean)
	Dim tbtn As ToggleButton = Sender
	expand_item(tbtn,Checked)
End Sub
Private Sub expand_item(tbtn As ToggleButton, expanded As Boolean)
	If expanded Then
		clv1.ResizeItem(tbtn.Tag, 200dip)
	Else
		clv1.ResizeItem(tbtn.Tag, 40dip)
	End If
End Sub
